diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/tutorial/tutorial-app.cc ns-3.36/examples/tutorial/tutorial-app.cc
--- ns-3.35/examples/tutorial/tutorial-app.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/tutorial/tutorial-app.cc	2022-04-30 18:23:57.726733000 -0700
@@ -0,0 +1,106 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#include "tutorial-app.h"
+#include "ns3/applications-module.h"
+
+using namespace ns3;
+
+TutorialApp::TutorialApp ()
+  : m_socket (0),
+    m_peer (),
+    m_packetSize (0),
+    m_nPackets (0),
+    m_dataRate (0),
+    m_sendEvent (),
+    m_running (false),
+    m_packetsSent (0)
+{
+}
+
+TutorialApp::~TutorialApp ()
+{
+  m_socket = 0;
+}
+
+/* static */
+TypeId TutorialApp::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("TutorialApp")
+    .SetParent<Application> ()
+    .SetGroupName ("Tutorial")
+    .AddConstructor<TutorialApp> ()
+    ;
+  return tid;
+}
+
+void
+TutorialApp::Setup (Ptr<Socket> socket, Address address, uint32_t packetSize, uint32_t nPackets, DataRate dataRate)
+{
+  m_socket = socket;
+  m_peer = address;
+  m_packetSize = packetSize;
+  m_nPackets = nPackets;
+  m_dataRate = dataRate;
+}
+
+void
+TutorialApp::StartApplication (void)
+{
+  m_running = true;
+  m_packetsSent = 0;
+  m_socket->Bind ();
+  m_socket->Connect (m_peer);
+  SendPacket ();
+}
+
+void
+TutorialApp::StopApplication (void)
+{
+  m_running = false;
+
+  if (m_sendEvent.IsRunning ())
+    {
+      Simulator::Cancel (m_sendEvent);
+    }
+
+  if (m_socket)
+    {
+      m_socket->Close ();
+    }
+}
+
+void
+TutorialApp::SendPacket (void)
+{
+  Ptr<Packet> packet = Create<Packet> (m_packetSize);
+  m_socket->Send (packet);
+
+  if (++m_packetsSent < m_nPackets)
+    {
+      ScheduleTx ();
+    }
+}
+
+void
+TutorialApp::ScheduleTx (void)
+{
+  if (m_running)
+    {
+      Time tNext (Seconds (m_packetSize * 8 / static_cast<double> (m_dataRate.GetBitRate ())));
+      m_sendEvent = Simulator::Schedule (tNext, &TutorialApp::SendPacket, this);
+    }
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/tutorial/tutorial-app.h ns-3.36/examples/tutorial/tutorial-app.h
--- ns-3.35/examples/tutorial/tutorial-app.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/tutorial/tutorial-app.h	2022-04-30 18:23:57.726733000 -0700
@@ -0,0 +1,74 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ */
+
+#ifndef TUTORIAL_APP_H
+#define TUTORIAL_APP_H
+
+#include "ns3/core-module.h"
+#include "ns3/network-module.h"
+#include "ns3/internet-module.h"
+
+namespace ns3 {
+
+class Application;
+
+/**
+ * Tutorial - a simple Application sending packets.
+ */
+class TutorialApp : public Application
+{
+public:
+  TutorialApp ();
+  virtual ~TutorialApp ();
+
+  /**
+   * Register this type.
+   * \return The TypeId.
+   */
+  static TypeId GetTypeId (void);
+
+  /**
+   * Setup the socket.
+   * \param socket The socket.
+   * \param address The destination address.
+   * \param packetSize The packet size to transmit.
+   * \param nPackets The number of packets to transmit.
+   * \param dataRate the datarate to use.
+   */
+  void Setup (Ptr<Socket> socket, Address address, uint32_t packetSize, uint32_t nPackets, DataRate dataRate);
+
+private:
+  virtual void StartApplication (void);
+  virtual void StopApplication (void);
+
+  /// Schedule a new transmission.
+  void ScheduleTx (void);
+  /// Send a packet.
+  void SendPacket (void);
+
+  Ptr<Socket>     m_socket;       //!< The tranmission socket.
+  Address         m_peer;         //!< The destination address.
+  uint32_t        m_packetSize;   //!< The packet size.
+  uint32_t        m_nPackets;     //!< The number of pacts to send.
+  DataRate        m_dataRate;     //!< The datarate to use.
+  EventId         m_sendEvent;    //!< Send event.
+  bool            m_running;      //!< True if the application is running.
+  uint32_t        m_packetsSent;  //!< The number of pacts sent.
+};
+
+} // namespace ns3
+
+#endif /* TUTORIAL_APP_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/udp/CMakeLists.txt ns-3.36/examples/udp/CMakeLists.txt
--- ns-3.35/examples/udp/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/udp/CMakeLists.txt	2022-04-30 18:23:57.726733000 -0700
@@ -0,0 +1,8 @@
+build_example(
+  NAME udp-echo
+  SOURCE_FILES udp-echo.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libapplications}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/udp-client-server/CMakeLists.txt ns-3.36/examples/udp-client-server/CMakeLists.txt
--- ns-3.35/examples/udp-client-server/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/udp-client-server/CMakeLists.txt	2022-04-30 18:23:57.726733000 -0700
@@ -0,0 +1,17 @@
+build_example(
+  NAME udp-client-server
+  SOURCE_FILES udp-client-server.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libapplications}
+)
+
+build_example(
+  NAME udp-trace-client-server
+  SOURCE_FILES udp-trace-client-server.cc
+  LIBRARIES_TO_LINK
+    ${libcsma}
+    ${libinternet}
+    ${libapplications}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/CMakeLists.txt ns-3.36/examples/wireless/CMakeLists.txt
--- ns-3.35/examples/wireless/CMakeLists.txt	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.36/examples/wireless/CMakeLists.txt	2022-04-30 18:23:57.726733000 -0700
@@ -0,0 +1,287 @@
+build_example(
+  NAME mixed-wired-wireless
+  SOURCE_FILES mixed-wired-wireless.cc
+  LIBRARIES_TO_LINK
+    ${libwifi}
+    ${libapplications}
+    ${libolsr}
+    ${libnetanim}
+)
+
+build_example(
+  NAME wifi-80211e-txop
+  SOURCE_FILES wifi-80211e-txop.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-80211n-mimo
+  SOURCE_FILES wifi-80211n-mimo.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-adhoc
+  SOURCE_FILES wifi-adhoc.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-aggregation
+  SOURCE_FILES wifi-aggregation.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-ap
+  SOURCE_FILES wifi-ap.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-backward-compatibility
+  SOURCE_FILES wifi-backward-compatibility.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-blockack
+  SOURCE_FILES wifi-blockack.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-clear-channel-cmu
+  SOURCE_FILES wifi-clear-channel-cmu.cc
+  LIBRARIES_TO_LINK ${libinternet}
+                    ${libwifi}
+)
+
+build_example(
+  NAME wifi-dsss-validation
+  SOURCE_FILES wifi-dsss-validation.cc
+  LIBRARIES_TO_LINK ${libwifi}
+)
+
+build_example(
+  NAME wifi-he-network
+  SOURCE_FILES wifi-he-network.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-hidden-terminal
+  SOURCE_FILES wifi-hidden-terminal.cc
+  LIBRARIES_TO_LINK
+    ${libwifi}
+    ${libapplications}
+    ${libflow-monitor}
+)
+
+build_example(
+  NAME wifi-ht-network
+  SOURCE_FILES wifi-ht-network.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-mixed-network
+  SOURCE_FILES wifi-mixed-network.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-multi-tos
+  SOURCE_FILES wifi-multi-tos.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-multirate
+  SOURCE_FILES wifi-multirate.cc
+  LIBRARIES_TO_LINK
+    ${libinternet}
+    ${libwifi}
+    ${libolsr}
+    ${libapplications}
+    ${libflow-monitor}
+)
+
+build_example(
+  NAME wifi-ofdm-he-validation
+  SOURCE_FILES wifi-ofdm-he-validation.cc
+  LIBRARIES_TO_LINK ${libwifi}
+)
+
+build_example(
+  NAME wifi-ofdm-ht-validation
+  SOURCE_FILES wifi-ofdm-ht-validation.cc
+  LIBRARIES_TO_LINK ${libwifi}
+)
+
+build_example(
+  NAME wifi-ofdm-validation
+  SOURCE_FILES wifi-ofdm-validation.cc
+  LIBRARIES_TO_LINK ${libwifi}
+)
+
+build_example(
+  NAME wifi-ofdm-vht-validation
+  SOURCE_FILES wifi-ofdm-vht-validation.cc
+  LIBRARIES_TO_LINK
+    ${libcore}
+    ${libmobility}
+    ${libwifi}
+    ${libconfig-store}
+    ${libstats}
+)
+
+build_example(
+  NAME wifi-error-models-comparison
+  SOURCE_FILES wifi-error-models-comparison.cc
+  LIBRARIES_TO_LINK ${libwifi}
+)
+
+build_example(
+  NAME wifi-power-adaptation-distance
+  SOURCE_FILES wifi-power-adaptation-distance.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-power-adaptation-interference
+  SOURCE_FILES wifi-power-adaptation-interference.cc
+  LIBRARIES_TO_LINK
+    ${libwifi}
+    ${libapplications}
+    ${libflow-monitor}
+)
+
+build_example(
+  NAME wifi-rate-adaptation-distance
+  SOURCE_FILES wifi-rate-adaptation-distance.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-simple-adhoc
+  SOURCE_FILES wifi-simple-adhoc.cc
+  LIBRARIES_TO_LINK ${libinternet}
+                    ${libwifi}
+)
+
+build_example(
+  NAME wifi-simple-adhoc-grid
+  SOURCE_FILES wifi-simple-adhoc-grid.cc
+  LIBRARIES_TO_LINK
+    ${libinternet}
+    ${libwifi}
+    ${libolsr}
+)
+
+build_example(
+  NAME wifi-simple-ht-hidden-stations
+  SOURCE_FILES wifi-simple-ht-hidden-stations.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-simple-infra
+  SOURCE_FILES wifi-simple-infra.cc
+  LIBRARIES_TO_LINK ${libinternet}
+                    ${libwifi}
+)
+
+build_example(
+  NAME wifi-simple-interference
+  SOURCE_FILES wifi-simple-interference.cc
+  LIBRARIES_TO_LINK ${libinternet}
+                    ${libwifi}
+)
+
+build_example(
+  NAME wifi-sleep
+  SOURCE_FILES wifi-sleep.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-spatial-reuse
+  SOURCE_FILES wifi-spatial-reuse.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-spectrum-per-example
+  SOURCE_FILES wifi-spectrum-per-example.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-spectrum-per-interference
+  SOURCE_FILES wifi-spectrum-per-interference.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-spectrum-saturation-example
+  SOURCE_FILES wifi-spectrum-saturation-example.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-tcp
+  SOURCE_FILES wifi-tcp.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-timing-attributes
+  SOURCE_FILES wifi-timing-attributes.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-txop-aggregation
+  SOURCE_FILES wifi-txop-aggregation.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-vht-network
+  SOURCE_FILES wifi-vht-network.cc
+  LIBRARIES_TO_LINK ${libwifi}
+                    ${libapplications}
+)
+
+build_example(
+  NAME wifi-wired-bridging
+  SOURCE_FILES wifi-wired-bridging.cc
+  LIBRARIES_TO_LINK
+    ${libwifi}
+    ${libcsma}
+    ${libbridge}
+    ${libapplications}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/examples-to-run.py ns-3.36/examples/wireless/examples-to-run.py
--- ns-3.35/examples/wireless/examples-to-run.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/examples-to-run.py	2022-04-30 18:23:57.726733000 -0700
@@ -42,8 +42,8 @@
     ("wifi-ht-network --simulationTime=0.2 --frequency=5 --useRts=1 --minExpectedThroughput=5 --maxExpectedThroughput=131", "True", "True"),
     ("wifi-ht-network --simulationTime=0.2 --frequency=2.4 --useRts=0 --minExpectedThroughput=5 --maxExpectedThroughput=132", "True", "True"),
     ("wifi-ht-network --simulationTime=0.2 --frequency=2.4 --useRts=1 --minExpectedThroughput=5 --maxExpectedThroughput=128", "True", "True"),
-    ("wifi-vht-network --simulationTime=0.2 --useRts=0  --minExpectedThroughput=5 --maxExpectedThroughput=562", "True", "True"),
-    ("wifi-vht-network --simulationTime=0.2 --useRts=1  --minExpectedThroughput=5 --maxExpectedThroughput=525", "True", "True"),
+    ("wifi-vht-network --simulationTime=0.2 --useRts=0  --minExpectedThroughput=5 --maxExpectedThroughput=583", "True", "True"),
+    ("wifi-vht-network --simulationTime=0.2 --useRts=1  --minExpectedThroughput=5 --maxExpectedThroughput=543", "True", "True"),
     ("wifi-he-network --simulationTime=0.25 --frequency=5 --useRts=0 --minExpectedThroughput=6 --maxExpectedThroughput=844", "True", "True"),
     ("wifi-he-network --simulationTime=0.3 --frequency=5 --useRts=0 --useExtendedBlockAck=1 --minExpectedThroughput=6 --maxExpectedThroughput=1033", "True", "True"),
     ("wifi-he-network --simulationTime=0.3 --frequency=5 --useRts=1 --minExpectedThroughput=6 --maxExpectedThroughput=745", "True", "True"),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/mixed-wired-wireless.cc ns-3.36/examples/wireless/mixed-wired-wireless.cc
--- ns-3.35/examples/wireless/mixed-wired-wireless.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/mixed-wired-wireless.cc	2022-04-30 18:23:57.726733000 -0700
@@ -295,7 +295,6 @@
       ss << i;
       ssidString += ss.str ();
       Ssid ssid = Ssid (ssidString);
-      wifiInfra.SetRemoteStationManager ("ns3::ArfWifiManager");
       // setup stas
       macInfra.SetType ("ns3::StaWifiMac",
                         "Ssid", SsidValue (ssid));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/mixed-wired-wireless.py ns-3.36/examples/wireless/mixed-wired-wireless.py
--- ns-3.35/examples/wireless/mixed-wired-wireless.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/mixed-wired-wireless.py	2022-04-30 18:23:57.726733000 -0700
@@ -260,7 +260,6 @@
         ssid = ns.wifi.Ssid('wifi-infra' + str(i))
         wifiInfra = ns.wifi.WifiHelper()
         wifiPhy.SetChannel(wifiChannel.Create())
-        wifiInfra.SetRemoteStationManager('ns3::ArfWifiManager')
         macInfra = ns.wifi.WifiMacHelper();
         macInfra.SetType("ns3::StaWifiMac",
                          "Ssid", ns.wifi.SsidValue(ssid))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/wifi-80211e-txop.cc ns-3.36/examples/wireless/wifi-80211e-txop.cc
--- ns-3.35/examples/wireless/wifi-80211e-txop.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/wifi-80211e-txop.cc	2022-04-30 18:23:57.726733000 -0700
@@ -55,7 +55,7 @@
 //
 // The user can select the distance between the stations and the APs, can enable/disable the RTS/CTS mechanism
 // and can choose the payload size and the simulation duration.
-// Example: ./waf --run "wifi-80211e-txop --distance=10 --simulationTime=20 --payloadSize=1000"
+// Example: ./ns3 run "wifi-80211e-txop --distance=10 --simulationTime=20 --payloadSize=1000"
 //
 // The output prints the throughput measured for the 4 cases/networks described above. When TXOP is enabled, results show
 // increased throughput since the channel is granted for a longer duration. TXOP is enabled by default for AC_VI and AC_VO,
@@ -70,8 +70,14 @@
  */
 struct TxopDurationTracer
 {
+  /**
+   * Callback connected to TXOP duration trace source.
+   *
+   * \param startTime TXOP start time
+   * \param duration TXOP duration
+   */
   void Trace (Time startTime, Time duration);
-  Time m_max {Seconds (0)};
+  Time m_max {Seconds (0)};     //!< maximum TXOP duration
 };
 
 void
@@ -109,7 +115,8 @@
   phy.SetPcapDataLinkType (WifiPhyHelper::DLT_IEEE802_11_RADIO);
   phy.SetChannel (channel.Create ());
 
-  WifiHelper wifi; //the default standard of 802.11a will be selected by this helper since the program doesn't specify another one
+  WifiHelper wifi;
+  wifi.SetStandard (WIFI_STANDARD_80211a);
   wifi.SetRemoteStationManager ("ns3::IdealWifiManager");
   WifiMacHelper mac;
 
@@ -118,7 +125,7 @@
 
   //Network A
   ssid = Ssid ("network-A");
-  phy.Set ("ChannelNumber", UintegerValue (36));
+  phy.Set ("ChannelSettings", StringValue ("{36, 20, BAND_5GHZ, 0}"));
   mac.SetType ("ns3::StaWifiMac",
                "QosSupported", BooleanValue (true),
                "Ssid", SsidValue (ssid));
@@ -132,7 +139,7 @@
 
   //Network B
   ssid = Ssid ("network-B");
-  phy.Set ("ChannelNumber", UintegerValue (40));
+  phy.Set ("ChannelSettings", StringValue ("{40, 20, BAND_5GHZ, 0}"));
   mac.SetType ("ns3::StaWifiMac",
                "QosSupported", BooleanValue (true),
                "Ssid", SsidValue (ssid));
@@ -166,7 +173,7 @@
 
   //Network C
   ssid = Ssid ("network-C");
-  phy.Set ("ChannelNumber", UintegerValue (44));
+  phy.Set ("ChannelSettings", StringValue ("{44, 20, BAND_5GHZ, 0}"));
   mac.SetType ("ns3::StaWifiMac",
                "QosSupported", BooleanValue (true),
                "Ssid", SsidValue (ssid));
@@ -190,7 +197,7 @@
 
   //Network D
   ssid = Ssid ("network-D");
-  phy.Set ("ChannelNumber", UintegerValue (48));
+  phy.Set ("ChannelSettings", StringValue ("{48, 20, BAND_5GHZ, 0}"));
   mac.SetType ("ns3::StaWifiMac",
                "QosSupported", BooleanValue (true),
                "Ssid", SsidValue (ssid));
@@ -387,7 +394,7 @@
   throughput = totalPacketsThroughC * payloadSize * 8 / (simulationTime * 1000000.0);
   std::cout << "AC_VI with default TXOP limit (3.008ms): " << '\n'
             << "  Throughput = " << throughput << " Mbit/s" << '\n';
-  if (verifyResults && (throughput < 35 || throughput > 36))
+  if (verifyResults && (throughput < 35.5 || throughput > 36.5))
     {
       NS_LOG_ERROR ("Obtained throughput " << throughput << " is not in the expected boundaries!");
       exit (1);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/wifi-80211n-mimo.cc ns-3.36/examples/wireless/wifi-80211n-mimo.cc
--- ns-3.35/examples/wireless/wifi-80211n-mimo.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/wifi-80211n-mimo.cc	2022-04-30 18:23:57.726733000 -0700
@@ -30,6 +30,12 @@
 //
 // The user can choose whether UDP or TCP should be used and can configure
 // some 802.11n parameters (frequency, channel width and guard interval).
+//
+// An important configuration parameter is preamble detection.  It is enabled
+// by default (to match the default ns-3 configuration) but will dominate
+// performance at low SNRs, causing the different MCS to appear to have
+// the same range (because regardless of the MCS, the preamble detection
+// thresholds do not change).
 
 #include "ns3/gnuplot.h"
 #include "ns3/command-line.h"
@@ -96,11 +102,13 @@
   double step = 5; //meters
   bool shortGuardInterval = false;
   bool channelBonding = false;
+  bool preambleDetection = true;
 
   CommandLine cmd (__FILE__);
   cmd.AddValue ("step", "Granularity of the results to be plotted in meters", step);
   cmd.AddValue ("simulationTime", "Simulation time per step (in seconds)", simulationTime);
   cmd.AddValue ("channelBonding", "Enable/disable channel bonding (channel width = 20 MHz if false, channel width = 40 MHz if true)", channelBonding);
+  cmd.AddValue ("preambleDetection", "Enable/disable preamble detection model", preambleDetection);
   cmd.AddValue ("shortGuardInterval", "Enable/disable short guard interval", shortGuardInterval);
   cmd.AddValue ("frequency", "Whether working in the 2.4 or 5.0 GHz band (other values gets rejected)", frequency);
   cmd.AddValue ("udp", "UDP if set to 1, TCP otherwise", udp);
@@ -136,21 +144,29 @@
           YansWifiChannelHelper channel = YansWifiChannelHelper::Default ();
           YansWifiPhyHelper phy;
           phy.SetChannel (channel.Create ());
+          if (!preambleDetection)
+            {
+              phy.DisablePreambleDetectionModel ();
+            }
 
           // Set MIMO capabilities
           phy.Set ("Antennas", UintegerValue (nStreams));
           phy.Set ("MaxSupportedTxSpatialStreams", UintegerValue (nStreams));
           phy.Set ("MaxSupportedRxSpatialStreams", UintegerValue (nStreams));
+          phy.Set ("ChannelSettings", StringValue (std::string ("{0, ")
+                                                   + (channelBonding ? "40, " : "20, ")
+                                                   + (frequency == 2.4 ? "BAND_2_4GHZ" : "BAND_5GHZ")
+                                                   + ", 0}"));
 
           WifiMacHelper mac;
           WifiHelper wifi;
           if (frequency == 5.0)
             {
-              wifi.SetStandard (WIFI_STANDARD_80211n_5GHZ);
+              wifi.SetStandard (WIFI_STANDARD_80211n);
             }
           else if (frequency == 2.4)
             {
-              wifi.SetStandard (WIFI_STANDARD_80211n_2_4GHZ);
+              wifi.SetStandard (WIFI_STANDARD_80211n);
               Config::SetDefault ("ns3::LogDistancePropagationLossModel::ReferenceLoss", DoubleValue (40.046));
             }
           else
@@ -186,12 +202,6 @@
           NetDeviceContainer apDevice;
           apDevice = wifi.Install (phy, mac, wifiApNode);
 
-          // Set channel width
-          if (channelBonding)
-            {
-              Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Phy/ChannelWidth", UintegerValue (40));
-            }
-
           // Set guard interval
           Config::Set ("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/ShortGuardIntervalSupported", BooleanValue (shortGuardInterval));
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/wifi-adhoc.cc ns-3.36/examples/wireless/wifi-adhoc.cc
--- ns-3.35/examples/wireless/wifi-adhoc.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/wifi-adhoc.cc	2022-04-30 18:23:57.726733000 -0700
@@ -37,22 +37,63 @@
 
 NS_LOG_COMPONENT_DEFINE ("Wifi-Adhoc");
 
+/**
+ * WiFi adhoc experiment class.
+ * 
+ * It handles the creation and run of an experiment.
+ */
 class Experiment
 {
 public:
   Experiment ();
+  /**
+   * Constructor.
+   * \param name The name of the experiment.
+   */
   Experiment (std::string name);
+
+  /**
+   * Run an experiment.
+   * \param wifi      //!< The WifiHelper class.
+   * \param wifiPhy   //!< The YansWifiPhyHelper class.
+   * \param wifiMac   //!< The WifiMacHelper class.
+   * \param wifiChannel //!< The YansWifiChannelHelper class.
+   * \return a 2D dataset of the experiment data. 
+   */
   Gnuplot2dDataset Run (const WifiHelper &wifi, const YansWifiPhyHelper &wifiPhy,
                         const WifiMacHelper &wifiMac, const YansWifiChannelHelper &wifiChannel);
 private:
+  /**
+   * Receive a packet.
+   * \param socket The recieving socket.
+   */
   void ReceivePacket (Ptr<Socket> socket);
+  /**
+   * Set the position of a node.
+   * \param node The node.
+   * \param position The position of the node.
+   */
   void SetPosition (Ptr<Node> node, Vector position);
+  /**
+   * Get the position of a node.
+   * \param node The node.
+   * \return the position of the node.
+   */
   Vector GetPosition (Ptr<Node> node);
+  /**
+   * Move a node by 1m on the x axis, stops at 210m.
+   * \param node The node.
+   */
   void AdvancePosition (Ptr<Node> node);
+  /**
+   * Setup the receiving socket.
+   * \param node The receiving node.
+   * \return the socket.
+   */
   Ptr<Socket> SetupPacketReceive (Ptr<Node> node);
 
-  uint32_t m_bytesTotal;
-  Gnuplot2dDataset m_output;
+  uint32_t m_bytesTotal;      //!< The number of received bytes.
+  Gnuplot2dDataset m_output;  //!< The output dataset.
 };
 
 Experiment::Experiment ()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/wifi-aggregation.cc ns-3.36/examples/wireless/wifi-aggregation.cc
--- ns-3.35/examples/wireless/wifi-aggregation.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/wifi-aggregation.cc	2022-04-30 18:23:57.726733000 -0700
@@ -56,7 +56,7 @@
 //Packets in this simulation belong to BestEffort Access Class (AC_BE).
 //
 // The user can select the distance between the stations and the APs and can enable/disable the RTS/CTS mechanism.
-// Example: ./waf --run "wifi-aggregation --distance=10 --enableRts=0 --simulationTime=20"
+// Example: ./ns3 run "wifi-aggregation --distance=10 --enableRts=0 --simulationTime=20"
 //
 // The output prints the throughput measured for the 4 cases/networks described above. When default aggregation parameters are enabled, the
 // maximum A-MPDU size is 65 kB and the throughput is maximal. When aggregation is disabled, the throughput is about the half of the physical
@@ -103,7 +103,7 @@
   phy.SetChannel (channel.Create ());
 
   WifiHelper wifi;
-  wifi.SetStandard (WIFI_STANDARD_80211n_5GHZ);
+  wifi.SetStandard (WIFI_STANDARD_80211n);
   wifi.SetRemoteStationManager ("ns3::ConstantRateWifiManager", "DataMode", StringValue ("HtMcs7"), "ControlMode", StringValue ("HtMcs0"));
   WifiMacHelper mac;
 
@@ -112,7 +112,7 @@
 
   // Network A
   ssid = Ssid ("network-A");
-  phy.Set ("ChannelNumber", UintegerValue (36));
+  phy.Set ("ChannelSettings", StringValue ("{36, 0, BAND_5GHZ, 0}"));
   mac.SetType ("ns3::StaWifiMac",
                "Ssid", SsidValue (ssid));
   staDeviceA = wifi.Install (phy, mac, wifiStaNodes.Get (0));
@@ -124,7 +124,7 @@
 
   // Network B
   ssid = Ssid ("network-B");
-  phy.Set ("ChannelNumber", UintegerValue (40));
+  phy.Set ("ChannelSettings", StringValue ("{40, 0, BAND_5GHZ, 0}"));
   mac.SetType ("ns3::StaWifiMac",
                "Ssid", SsidValue (ssid));
 
@@ -147,7 +147,7 @@
 
   // Network C
   ssid = Ssid ("network-C");
-  phy.Set ("ChannelNumber", UintegerValue (44));
+  phy.Set ("ChannelSettings", StringValue ("{44, 0, BAND_5GHZ, 0}"));
   mac.SetType ("ns3::StaWifiMac",
                "Ssid", SsidValue (ssid));
 
@@ -172,7 +172,7 @@
 
   // Network D
   ssid = Ssid ("network-D");
-  phy.Set ("ChannelNumber", UintegerValue (48));
+  phy.Set ("ChannelSettings", StringValue ("{48, 0, BAND_5GHZ, 0}"));
   mac.SetType ("ns3::StaWifiMac",
                "Ssid", SsidValue (ssid));
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/wifi-ap.cc ns-3.36/examples/wireless/wifi-ap.cc
--- ns-3.35/examples/wireless/wifi-ap.cc	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/wifi-ap.cc	2022-04-30 18:23:57.726733000 -0700
@@ -140,7 +140,6 @@
   YansWifiChannelHelper wifiChannel = YansWifiChannelHelper::Default ();
   wifiPhy.SetChannel (wifiChannel.Create ());
   Ssid ssid = Ssid ("wifi-default");
-  wifi.SetRemoteStationManager ("ns3::ArfWifiManager");
   // setup stas.
   wifiMac.SetType ("ns3::StaWifiMac",
                    "ActiveProbing", BooleanValue (true),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/examples/wireless/wifi-ap.py ns-3.36/examples/wireless/wifi-ap.py
--- ns-3.35/examples/wireless/wifi-ap.py	2021-10-01 13:26:47.000000000 -0700
+++ ns-3.36/examples/wireless/wifi-ap.py	2022-04-30 18:23:57.726733000 -0700
@@ -118,7 +118,6 @@
     wifiPhy.SetChannel(wifiChannel.Create())
 
     ssid = ns.wifi.Ssid("wifi-default")
-    wifi.SetRemoteStationManager("ns3::ArfWifiManager")
     wifiMac = ns.wifi.WifiMacHelper()
 
     # setup stas.
